from bitcoding import B_dict
from basesplit import bsplit as split
from inverse import inv
from glob import globs

if globs['pcheuristic'] == 0: # path consistency
   from pc import PC as pc 
elif globs['pcheuristic'] == 1: # path consistency with weighted queue
   from pcw import PCw as pc

def extractFeasible(solution, ConMatrixS, neighbors, fill):

   for (i,j) in fill:
      rel = ((solution[i][j]^ConMatrixS[i][j])&solution[i][j])
      if rel:
         for b in split[rel-1][1]:
            repairs = {}
            repairs[(i,j)] = solution[i][j]
            solution[i][j] = b
            solution[j][i] = inv[b-1]                  
            result = pc(solution, neighbors, i, j, repairs, [], False)
            for g, h in repairs.keys():
               solution[g][h] = repairs[(g, h)] 
               solution[h][g] = inv[repairs[(g, h)]-1]
            if result:
               ConMatrixS[i][j] += b
               ConMatrixS[j][i] += inv[b-1] 
            
